﻿--[[
	Author: Darcey@AllForTheCode.co.uk
--]]

local origin = "BOTTOMLEFT";

-- initFunctions
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

function initDCoordsMainFrame()
	DCoordsMainFrame = CreateFrame("frame","DCoordsMainFrameFrame",UIparent);
	local win = DCoordsMainFrame;
	--DCoordsMainFrame:SetFrameStrata("FULLSCREEN_DIALOG")
	DCoordsMainFrame.texture = DCoordsMainFrame:CreateTexture (nil, "background");
	DCoordsMainFrame.texture:SetColorTexture(0, 0, 0, 0.5);
	DCoordsMainFrame.texture:SetAllPoints(true);
	DCoordsMainFrame:SetWidth(DCoords_MainFrameWidth);
	DCoordsMainFrame:SetHeight(DCoords_MainFrameHeight);
	DCoordsMainFrame:EnableMouse(false);
	DCoordsMainFrame:SetResizable(true);
	DCoordsMainFrame:SetMovable(true);
	DCoordsMainFrame:SetPoint("CENTER",0,0);
	DCoordsMainFrame:SetScript("OnUpdate", function(self) DCoordsMainFrameUpdateHandler() end);
	DCoordsMainFrame:SetScript("OnMouseUp", function(self,buttonIdentifier) mouseUpHandler(self,buttonIdentifier) end);

	
	DCoordsMainFrameText = DCoordsMainFrame:CreateFontString(nil, 'ARTWORK');
	DCoordsMainFrameText:SetAllPoints();
	DCoordsMainFrameText:SetFont(getMainFrameFont(), DCoords_MainFrameFontSize);
	DCoordsMainFrameText:SetShadowOffset(1, -1);
	DCoordsMainFrameText:SetTextColor(1, 1, 1)
	DCoordsMainFrameText:SetNonSpaceWrap(false);
	DCoordsMainFrameText:SetText("Darcey@AllForTheCode.co.uk");
	
	
	--[[
	DCoordsMainFrame:EnableMouseWheel (true);
	DCoordsMainFrame:SetScript("OnMouseWheel", function (self, delta)
		if (delta > 0) then
			DCoords_MainFrameWidth = DCoords_MainFrameWidth+10;
			DCoords_MainFrameHeight = DCoords_MainFrameHeight+0.4;
			DCoords_MainFrameFontSize = DCoords_MainFrameFontSize+0.3;
		elseif (delta < 0) then
			if (DCoords_MainFrameWidth < 100) then
				return;
			end
			DCoords_MainFrameWidth = DCoords_MainFrameWidth-10;
			DCoords_MainFrameHeight = DCoords_MainFrameHeight-0.4;
			DCoords_MainFrameFontSize = DCoords_MainFrameFontSize-0.3;
		end
		self:SetWidth(DCoords_MainFrameWidth);
		self:SetHeight(DCoords_MainFrameHeight);
		DCoordsMainFrameText:SetFont(getMainFrameFont(), DCoords_MainFrameFontSize)
		DCoordsMainFrameText:SetWidth(DCoords_MainFrameWidth);
		DCoordsMainFrameText:SetHeight(20);
		
	end)
	--]]
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function updateDCoordsMainFrame()

	-- Visibility
	if (DCoords_MainFrameVisible == true) then
		DCoordsMainFrame:Show();
	else
		DCoordsMainFrame:Hide();
	end

	-- Width, Height and Font
	DCoordsMainFrame:SetWidth(DCoords_MainFrameWidth);
	DCoordsMainFrame:SetHeight(DCoords_MainFrameHeight);
	DCoordsMainFrameText:SetFont(getMainFrameFont(), DCoords_MainFrameFontSize);
	
	-- Position (Had to do it manually)
	DCoordsMainFrame:SetPoint(origin,DCoords_MainFrameX,(DCoords_MainFrameY-10));

	-- Drag
	if (DCoords_MainFrameDragEnabled == true) then
		
		DCoordsMainFrame:RegisterForDrag("LeftButton");
		
		DCoordsMainFrame:SetScript("OnDragStart", function(self) 
			toChat("DCoords: Drag started!"); self:StartMoving(); 
		end);
		
		DCoordsMainFrame:SetScript("OnDragStop", function(self)
			--DCoords_MainFrameX = (GetScreenWidth()/2) - DCoordsMainFrame:GetLeft()
			--DCoords_MainFrameY = (GetScreenHeight()/2) + DCoordsMainFrame:GetTop()
			DCoords_MainFrameX = DCoordsMainFrame:GetLeft()
			DCoords_MainFrameY = DCoordsMainFrame:GetTop()
			log("DCoords_MainFrameX = " .. DCoords_MainFrameX);
			log("DCoords_MainFrameY = " .. DCoords_MainFrameY);  
			self:StopMovingOrSizing()
		end);
			
	else
		DCoordsMainFrame:RegisterForDrag(nil);
		DCoordsMainFrame:SetScript("OnDragStart",nil);
		DCoordsMainFrame:SetScript("OnDragStop", nil);
	end
	

	-- BG
	if (DCoords_MainFrameShowBg == true) then
		DCoordsMainFrame.texture:SetAlpha(1);
	else
		DCoordsMainFrame.texture:SetAlpha(0);
	end
	
	-- FontSize (NOTE: Height is only usable for small sizes, use SetTExtHeight to fontsize to fix)
	local txtW = DCoordsMainFrameText:GetStringWidth() + 20;
	--local txtH = DCoordsMainFrameText:GetStringHeight();
	DCoordsMainFrame:SetWidth(txtW);
	DCoordsMainFrame:SetHeight(DCoords_MainFrameFontSize);
	--DCoordsMainFrameText:SetTextHeight(DCoords_MainFrameFontSize); 
	
	
	-- Text color	
	DCoordsMainFrameText:SetTextColor(DCoords_MainFrameTextR,DCoords_MainFrameTextG,DCoords_MainFrameTextB,DCoords_MainFrameTextAlpha);
	
	-- TExt alpha
	DCoordsMainFrameText:SetAlpha(DCoords_MainFrameTextAlpha);
	
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsSlashCommandHandler(cmd)
	log("DCoordsSlashCommandHandler(): " .. cmd);
	
	if (cmd == nil or cmd == "" or string.find(cmd, "help") ~= nil) then
		toChat(" ");
		toChat("DCoords v" .. DCoordsVersion .. " slash commands:");
		toChat("  /DC show menu - show menu");
		toChat("  /DC hide menu - hide menu");
		toChat("  /DC menu - toggle menu visibility");
		toChat("  /DC show  - show coordinates");
		toChat("  /DC hide - hide coordinates");
		toChat("  /DC reset - reset position and settings");
		return;
	end
	
	strSearchResult = string.find(cmd,"reset");
	if (strSearchResult ~= nil) then
		trace("DCoords attempting to reset positions...");
		reset();
		ReloadUI();
		return;
	end
	
	if (cmd == "menu") then
		if (DCoordsMenuFrame:IsVisible()) then
			DCoordsMenuFrame:Hide();
		else
			DCoordsMenuFrame:Show();
		end
		return;
	end
	
	if (cmd == "show menu") then
		DCoordsMenuFrame:Show();
		return;
	end
	
	if (cmd == "hide menu") then
		DCoordsMenuFrame:Hide();
		return;
	end
	
	if (cmd == "show") then
		DCoordsMainFrame:Show();
		return;
	end
	
	if (cmd == "hide") then
		DCoordsMainFrame:Hide();
		return;
	end
	
	
	updateDCoordsMainFrame();
	updateDCoordsMapFrameState();
	updateDCoordsMenuFrameState();
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






-- eventHandlerFunctions
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

function mouseUpHandler(self,buttonIdentifier)

	if (buttonIdentifier == "RightButton") then
		playClick();
		if (DCoordsMenuFrame:IsVisible()) then
			DCoordsMenuFrame:Hide();
		else
			DCoordsMenuFrame:Show();
		end
	end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- init/constructor
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
local DCoordsEventsFrame = CreateFrame("FRAME");
DCoordsEventsFrame:RegisterEvent("ADDON_LOADED");
DCoordsEventsFrame:RegisterEvent("VARIABLES_LOADED");
DCoordsEventsFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
DCoordsEventsFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
DCoordsEventsFrame:RegisterEvent("ZONE_CHANGED");
DCoordsEventsFrame:RegisterEvent("PLAYER_LOGOUT");
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
DCoordsEventsFrame:SetScript("OnEvent", function(self,event,addonName)	
	if (event == "ADDON_LOADED") then
		if (addonName == "DCoords") then
			log("DCoords v"..DCoordsVersion.." ADDON_LOADED!");
		end
	elseif (event == "VARIABLES_LOADED") then
		log("DCoords v"..DCoordsVersion.." VARIABLES_LOADED!");
		DCoordsInit();
	else
		log("DCoords: WARNING: Unhandled event: [" .. event .. "]");
	end
end);
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function DCoordsInit()
	-- One time calls
	SetMapToCurrentZone(); -- Works anyway but could be another addon doing that
	
	-- Register events
	DCoordsEventsFrame:RegisterEvent("VARIABLES_LOADED");
	DCoordsEventsFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	
	-- DCoordsMain
	initDCoordsMainFrame();
	
	-- DCoordsMap
	initDCoordsMapFrame();
	
	-- DCoordsMenu
	initDCoordsMenuFrame();
	
	-- Update for full init
	updateDCoordsMainFrame();
	updateDCoordsMapFrameState();
	updateDCoordsMenuFrameState();
	DCoordsMenuFrame:Hide();
	
	
	
	-- Setup slash commands
	SlashCmdList["DCoordsCOMMAND"] = DCoordsSlashCommandHandler;
	SLASH_DCoordsCOMMAND1 = "/dc";
	
	
	
	toChat(" ");
	toChat("DCoords v"..DCoordsVersion);
	toChat("DCoords: To view the menu right click coordinates bar or");
	toChat("DCoords: type /DC menu.");
	toChat("DCoords: For more information type /DC help or /DC");
	
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #


